# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define namedversion 1.0.0-Alpha-2

Name:           jboss-ejb3-embedded
Version:        1.0.0
Release:        0.a2.1%{?dist}
Epoch:          0
Summary:        JBoss EJB3 Embedded
License:        LGPL
Group:          Development/Java
URL:            http://www.jboss.org/
Source0:        jboss-ejb3-embedded-1.0.0-Alpha-2.tar.gz
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/ejb3/tags/jboss-ejb3-embedded-1.0.0-Alpha-2/

Source1:        jboss-ejb3-embedded-jpp-depmap.xml
Source2:        jboss-ejb3-embedded-settings.xml
Source3:        http://repository.jboss.org/maven2/org/jboss/jboss-parent/4/jboss-parent-4.pom

Patch0:         jboss-ejb3-embedded-pom.patch
Patch1:         jboss-ejb3-embedded-AbstractEmbeddedTestCase.patch

BuildArch:      noarch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-rar
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-jboss-deploy-plugin
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release
BuildRequires:  maven-shared-enforcer-rule-api
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  ant-junit
BuildRequires:  hsqldb
BuildRequires:  jboss-common-logging-log4j
BuildRequires:  jboss-test
BuildRequires:  junit44

BuildRequires:  concurrent
BuildRequires:  jboss5-libs
BuildRequires:  jboss-aop2
BuildRequires:  jboss-bootstrap-impl-mc
BuildRequires:  jboss-common-core
BuildRequires:  jboss-deployers
BuildRequires:  jboss-ejb-3.1-api
BuildRequires:  jboss-ejb3-build
BuildRequires:  jboss-ejb3-core
BuildRequires:  jboss-ejb3-deployers
BuildRequires:  jboss-metadata
BuildRequires:  jboss-microcontainer2
BuildRequires:  jboss-naming
BuildRequires:  jboss-reflect
BuildRequires:  jboss-vfs
BuildRequires:  jbossts
BuildRequires:  jbossxb2
BuildRequires:  sun-ws-metadata-2.0-api
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

Requires:  java-devel >= 0:1.5.0
Requires:  concurrent
Requires:  jboss5-libs
Requires:  jboss-aop2
Requires:  jboss-bootstrap-impl-mc
Requires:  jboss-common-core
Requires:  jboss-deployers
Requires:  jboss-ejb-3.1-api
Requires:  jboss-ejb3-build
Requires:  jboss-ejb3-core
Requires:  jboss-ejb3-deployers
Requires:  jboss-metadata
Requires:  jboss-microcontainer2
Requires:  jboss-naming
Requires:  jboss-reflect
Requires:  jboss-vfs
Requires:  jbossts
Requires:  jbossxb2
Requires:  ws_metadata_2_0_api

%description
JBoss EJB embedded.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n %{name}-%{namedversion}
%patch0 -b .sav0
%patch1 -b .sav1

%build
cp %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
export MAVEN_OPTS="-Dmaven.test.failure.ignore=true -Dmaven.repo.local=$MAVEN_REPO_LOCAL -Dmaven2.jpp.depmap.file=%{SOURCE1} -DJDK6_HOME=%{_jvmdir}/java-1.6.0"
mkdir -p $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/
cp %{SOURCE3} $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/org.jboss-jboss-parent.pom
export JDK6_HOME=%{_jvmdir}/java-1.6.0
mkdir -p $MAVEN_REPO_LOCAL/javax.security/
ln -s %{_jvmdir}/java/jre/lib/rt.jar $MAVEN_REPO_LOCAL/javax.security/jaas.jar

mvn-jpp -e \
        -s ${M2SETTINGS} \
        install javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/%{name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%add_to_maven_depmap org.jboss.ejb3 %{name} %{namedversion} JPP %{name}
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -rf target/site/apidocs/* \
                  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog
* Tue Aug 25 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.0.0-0.a2.1
- first release

